<?php

namespace Drupal\video_embed_dailymotion\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;

/**
 * @VideoEmbedProvider(
 *   id = "dailymotion",
 *   title = @Translation("Dailymotion")
 * )
 */
class Dailymotion extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    return [
      '#type' => 'video_embed_iframe',
      '#provider' => 'dailymotion',
      '#url' => sprintf('//www.dailymotion.com/embed/video/%s', $this->getVideoId()),
      '#query' => [
        'autoPlay' => $autoplay,
      ],
      '#attributes' => [
        'width' => $width,
        'height' => $height,
        'frameborder' => '0',
        'allowfullscreen' => 'allowfullscreen',
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getRemoteThumbnailUrl() {
    return sprintf('https://www.dailymotion.com/thumbnail/video/%s', $this->getVideoId());
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    preg_match('/^https?:\/\/(www\.)?(dailymotion\.com|dai\.ly)\/(embed\/)?(video\/)?(?<id>[a-zA-Z0-9]*)(_([0-9a-zA-Z\-_])*)?$/', $input, $matches);
    return isset($matches['id']) ? $matches['id'] : FALSE;
  }

}
